/*
 *	app.h
 *
 *	CHIP/8 - P/ECE CHIP-8 Interpreter
 *
 *	* Mon Mar 22 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define USE_SPRITE /* ȈՃXvCghCogꍇ́ÃV{`Ă */
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
};
extern const SPRITE sprite_table[];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	60			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

//#define TEXTURE_LIST	PAT0,PAT1,PAT2	/* eNX`Xg */
//#define TEXTURE_COUNT	3		/* eNX`̐ */

#define CONFIG_FNAME	"chip8.cfg"	/* ݒۑt@C */

typedef struct _CONFIG {
	/* 1/60[sec]s閽ߐB */
	int spd;
	/* P/ECẼpbh͂ɑΉACHIP-8̃L[ԍ(0`15) */
	unsigned char pad[8];		/* 0:/1:E/2:E/3:E/4:/5:/6:/7: */
	unsigned char trg[2];		/* 0:A/1:B */
} CONFIG;
#define SPD_MIN		  1		/* CPUXs[h (1/60[sec]̖ߎs) ݒ艺 */
#define SPD_MAX		999		/* CPUXs[h (1/60[sec]̖ߎs) ݒ */

typedef struct _DRIVER {
	CHIP8 chip8;
	CONFIG config;
} DRIVER;

typedef struct _FILEITEM {
	char* fname;
	int len;
} FILEITEM;

void app_init();
void app_exit();
void schedule();
void app_main();

/* main.c */
void root_sel();
int arc_sel(const char* arcname);
int file_sel(const FILEITEM* file_list, int file_count, int cursel, int* curtop, int inarc);
void run(DRIVER* driver, const char* arcname, const char* fname);
void update_key(DRIVER* driver);
void show_config(DRIVER* driver, int sel);
int do_config(DRIVER* driver);
int load_config(CONFIG* config);
int save_config(const CONFIG* config);

#define ARCTYPE_ZIP	1
#define ARCTYPE_LZH	2
int get_arctype(const char* arcname);
int chip8_load_arc(CHIP8* chip8, const char* arcname, const char* fname);
int chip8_test_arc(const char* arcname, const char* fname, int cycle);

/* fram.c */
void update_screen(DRIVER* driver);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
